<template>
  <div v-if="user.authenticated">
    <h1>{{ booksTitle }}</h1>

    <div class="ui info message" v-if="loading">
      <icon name="refresh" spin></icon>&nbsp;&nbsp;
      Loading...
    </div>

    <div class="ui negative message" v-if="error">
      <div class="header">
        An error occured.
      </div>
      {{ error.message }}
      <p v-if="error.response.data">
      {{ error.response.data.Message }}
      </p>
    </div>

    <div class="ui positive message" v-if="success">
      <div class="header">
        Success
      </div>
      {{ success }}
    </div>

    <div v-if="!loading && !error">

      <router-link to="/books/add" class="ui green labeled icon button" style="float: right;">
        <i class="plus icon"></i>
        Add a book
      </router-link>

      <button @click="loadBooks()" class="ui teal labeled icon button" style="float: right;">
        <i class="refresh icon"></i>
        Refresh
      </button>

      <form id="search">
        <div class="ui icon input">
          <input placeholder="Search for anything..." type="text" v-model="searchQuery">
          <i class="search icon"></i>
        </div>
      </form>
      <paginate
        name="books"
        :list="filteredData"
        :per="35"
        tag="div"
      >
        <grid
          :data="paginated('books')"
          :columns="gridColumns"
          :buttons="gridButtons"
          :btnclick="gridBtnClicked"
        >
        </grid>
      </paginate>
      <div class="pagination-container">
        <paginate-links
          tag="div"
          for="books"
          :hide-single-page="true"
          :classes="{
            'ul': ['ui', 'pagination', 'menu'],
            'li': 'item',
            'li a': 'pagination-link'
          }"
        >
        </paginate-links>
        <div v-if="$refs.paginator">
          Viewing {{$refs.paginator.pageItemsCount}} results
        </div>
      </div>
    </div>
    <modal
      v-if="showModal"
      @close="showModal = false"
      v-on:submit="deleteBtnSuccess()">
      <span slot="header">Delete this book</span>
      <p slot="text">Are you sure you want to delete this book? This cannot be undone!</p>
    </modal>
  </div>
</template>

<script>
import auth from '../auth'
import {HTTP} from '../http-common'
import router from '../router'

export default {
  name: 'Home',
  data () {
    return {
      user: auth.user,
      booksTitle: 'Books Overview',
      books: [],
      searchQuery: '',
      gridColumns: ['Title', 'ISBN', 'Year', 'Price', 'Author', 'Publisher', 'Quantity', 'Status'],
      gridButtons: [
        {
          text: 'Delete',
          icon: 'trash',
          action: this.deleteBook,
          css: 'ui red icon button'
        },
        {
          text: '',
          icon: 'edit',
          action: this.editBook,
          css: 'ui blue icon button'
        }
      ],
      loading: false,
      paginate: ['books'],
      error: '',
      success: '',
      allStatus: [],
      showModal: false
    }
  },
  created () {
    this.loadStatus()
    this.loadBooks()
  },
  watch: {
    // call again the method if the route changes
    '$route': 'loadBooks'
  },
  computed: {
    filteredData: function () {
      var filterKey = this.searchQuery && this.searchQuery.toLowerCase()
      var data = this.books
      if (filterKey) {
        data = data.filter(function (row) {
          return Object.keys(row).some(function (key) {
            if (row[key].content) {
              return String(row[key].content).toLowerCase().indexOf(filterKey) > -1
            } else {
              return String(row[key]).toLowerCase().indexOf(filterKey) > -1
            }
          })
        })
      }
      return data
    }
  },
  methods: {
    loadBooks () {
      this.loading = true
      this.books = []
      HTTP.get(`books`)
        .then(response => {
          let bs = response.data
          let i = 0

          // Loop throught the data we got from our API and prepare an array to display all books
          for (const b in bs) {
            this.books[i] = {
              ID: {content: bs[b].ID, hide: true}, // Don't show the ID
              Title: {content: bs[b].Title, link: '/book/' + bs[b].ID}, // Add a link to the element
              ISBN: {content: bs[b].Isbn}, // We can also just use the content column
              Year: bs[b].Year,
              Price: bs[b].Price + '€',
              Author: '',
              Publisher: bs[b].PublisherFull.Name,
              Quantity: bs[b].Quantity,
              Status: bs[b].Status
            }

            // Get all authors and concat them into one singe string
            let authors = bs[b].Authors
            for (const au in authors) {
              this.books[i].Author += authors[au].Forename + ' ' + authors[au].Lastname
              if (authors.length > au + 1) {
                this.books[i].Author += ', '
              }
            }

            // Make Status a name, not an id
            this.books[i].Status = this.getStatusByID(this.books[i].Status)

            // increment dat shit
            i++
          }
          this.loading = false
        })
        .catch(e => {
          this.loading = false
          this.error = e
        })
    },
    loadStatus: function () {
      HTTP.get('status')
        .then(response => {
          this.allStatus = response.data
        })
        .catch(e => {
          this.error = e
        })
    },
    getStatusByID: function (id) {
      // TODO: is there a better way to do this?
      for (const i in this.allStatus) {
        if (this.allStatus[i].ID === id) {
          return this.allStatus[i].Name
        }
      }
      return ''
    },
    gridBtnClicked (opt, gridObject) {
      opt.action(gridObject)
    },
    deleteBtnSuccess () { // Event helper function
      this.$emit('delete-submit')
    },
    deleteBook (obj) {
      this.showModal = true
      this.$on('delete-submit', function () {
        HTTP.delete('books/' + obj.ID.content)
          .then(response => {
            console.log(response)
            if (response.status === 200 && response.data.Message === 'success') {
              this.success = 'The book was deleted successfully.'
              this.loadBooks()
            }
          })
          .catch(e => {
            this.error = e
          })
        this.showModal = false
      })
    },
    editBook (book) {
      router.push({ name: 'book-edit', params: { id: book.ID.content } })
    }
  }
}
</script>

<style>
  a.pagination-link{
    margin: -5px -1.14286em -18px;
    display: block;
    position: absolute;
    cursor: pointer;
    padding: 0.928571em 1.14286em;
    color: rgba(0,0,0,.87);

    -webkit-transition: background-color 200ms; /* Safari */
    transition: background-color 200ms;
  }

  a.pagination-link:hover{
    background: rgba(0,0,0,.02);
  }

  .pagination{
    padding: 0;
  }

  .pagination-container{
    margin-top: 1rem;
    text-align: center;
  }

  #search{
    margin-bottom: 1rem;
  }
</style>
